handler = (req, res) ->
	err = (req, res) ->
		res.writeHead(404, 'Content-Type': 'text/plain')
		return res.end("Error loading #{req.url}")
	switch req.url
		when '/', '/index.html'
			filename = __dirname + '/index.html'
			type = 'text/html'
		when '/jquery.js'
			filename = '/usr/share/javascript/jquery/jquery.min.js'
			type = 'text/javascript'
		else
			return err req, res
	fs.readFile filename, (err, data) ->
		return err req, res if err

		res.writeHead(200, 'Content-Type': type)
		res.end(data)

app = require('http').createServer(handler)
io = require('socket.io').listen(app)
fs = require('fs')
terminal = require('./terminal.coffee')

# SETTINGS
app.listen(9293)
term = terminal.new(105, 66)

io.sockets.on 'connection', (socket) ->
	# FIXME socket.emit 'write', term.getState()
	term.on 'sequence', (data) ->
		socket.emit 'write', "sequence: #{data}"
	term.on 'text', (data) ->
		socket.emit 'write', data
	socket.on 'disconnect', ->
		# FIXME stop term update callback
		console.log 'client disconnected'

process.stdin.resume()
process.stdin.setEncoding 'utf8'

process.stdin.on 'data', (data) ->
	term.update data

process.stdin.on 'end', -> process.exit()
